Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 3579)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 3582)
@@ -15,4 +15,5 @@
 ! PALM. If not, see <http://www.gnu.org/licenses/>.
 !
+! Copyright 2018-2018 University of Helsinki
 ! Copyright 1997-2018 Leibniz Universitaet Hannover
 !--------------------------------------------------------------------------------!
@@ -20,6 +21,10 @@
 ! Current revisions:
 ! -----------------
-! 
-! 
+! - Moved the control parameter "salsa" from salsa_mod.f90 to control_parameters
+! - Updated salsa_rrd_local and salsa_wrd_local
+! - Add target attribute
+! - Revise initialization in case of restarts
+! - Revise masked data output
+!
 ! Former revisions:
 ! -----------------
@@ -44,6 +49,6 @@
 ! Authors:
 ! --------
-! @author monakurppa
-!
+! @author Mona Kurppa (University of Helsinki)
+! 
 !
 ! Description:
@@ -60,6 +65,4 @@
 !>
 !> @todo Implement turbulent inflow of aerosols in inflow_turbulence.
-!> @todo Deposition on walls and horizontal surfaces calculated from the aerosol 
-!>       dry radius, not wet
 !> @todo Deposition on subgrid scale vegetation 
 !> @todo Deposition on vegetation calculated by default for deciduous broadleaf 
@@ -197,5 +200,4 @@
                                                 !< chemical components 
     LOGICAL ::  read_restart_data_salsa = .FALSE. !< read restart data for salsa
-    LOGICAL ::  salsa                 = .FALSE.   !< SALSA master switch
     LOGICAL ::  salsa_gases_from_chem = .FALSE.   !< Transfer the gaseous 
                                                   !< components to SALSA from  
@@ -420,9 +422,11 @@
                                                                     !< OC
 !-- Integrated:                                                                    
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  LDSA_av  !< lung deposited 
-                                                         !< surface area                                                    
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  Ntot_av  !< total number conc.
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  PM25_av  !< PM2.5
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:) ::  PM10_av  !< PM10
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  LDSA_av  !< lung-
+                                                                 !< deposited 
+                                                                 !< surface area                                                    
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  Ntot_av  !< total number
+                                                                 !< conc.
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  PM25_av  !< PM2.5
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  PM10_av  !< PM10
 !-- In the particle phase:    
     REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_BC_av  !< black carbon 
@@ -435,9 +439,8 @@
     REAL(wp), ALLOCATABLE, DIMENSION(:,:,:), TARGET ::  s_SS_av  !< sea salt
 !-- Bins:    
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::  mbins_av  !< bin mass 
-                                                            !< concentration 
-    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::  Nbins_av  !< bin number 
-                                                            !< concentration  
-        
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  mbins_av !< bin mass  
+    REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:), TARGET ::  Nbins_av !< bin number 
+
+    
 !
 !-- PALM interfaces:
@@ -564,4 +567,5 @@
            mconc_2, nbins, ncc, ncc_tot, nclim, nconc_2, ngast, prtcl, Ra_dry, &
            salsa_gas, sedim_vd
+           
 
  CONTAINS
@@ -688,6 +692,5 @@
 
 !
-!-- Set flag that indicates that the new module is switched on
-!-- Note that this parameter needs to be declared in modules.f90
+!-- Enable salsa (salsa switch in modules.f90)
     salsa = .TRUE.
 
@@ -1230,82 +1233,79 @@
     ENDDO
     
-    IF ( nldepo )  sedim_vd = 0.0_wp
+    IF ( nldepo )  sedim_vd = 0.0_wp  
+    
+    DO  b = 1, nbins
+       IF ( .NOT. read_restart_data_salsa )  aerosol_number(b)%conc = nclim
+       aerosol_number(b)%conc_p    = 0.0_wp
+       aerosol_number(b)%tconc_m   = 0.0_wp
+       aerosol_number(b)%flux_s    = 0.0_wp
+       aerosol_number(b)%diss_s    = 0.0_wp
+       aerosol_number(b)%flux_l    = 0.0_wp
+       aerosol_number(b)%diss_l    = 0.0_wp
+       aerosol_number(b)%init      = nclim
+       aerosol_number(b)%sums_ws_l = 0.0_wp
+    ENDDO
+    DO  c = 1, ncc_tot*nbins
+       IF ( .NOT. read_restart_data_salsa )  aerosol_mass(c)%conc = mclim
+       aerosol_mass(c)%conc_p    = 0.0_wp
+       aerosol_mass(c)%tconc_m   = 0.0_wp
+       aerosol_mass(c)%flux_s    = 0.0_wp
+       aerosol_mass(c)%diss_s    = 0.0_wp
+       aerosol_mass(c)%flux_l    = 0.0_wp
+       aerosol_mass(c)%diss_l    = 0.0_wp
+       aerosol_mass(c)%init      = mclim
+       aerosol_mass(c)%sums_ws_l = 0.0_wp
+    ENDDO
+    
+    IF ( .NOT. salsa_gases_from_chem )  THEN
+       DO  g = 1, ngast
+          salsa_gas(g)%conc_p    = 0.0_wp
+          salsa_gas(g)%tconc_m   = 0.0_wp
+          salsa_gas(g)%flux_s    = 0.0_wp
+          salsa_gas(g)%diss_s    = 0.0_wp
+          salsa_gas(g)%flux_l    = 0.0_wp
+          salsa_gas(g)%diss_l    = 0.0_wp
+          salsa_gas(g)%sums_ws_l = 0.0_wp
+       ENDDO
+       IF ( .NOT. read_restart_data_salsa )  THEN
+          salsa_gas(1)%conc = H2SO4_init
+          salsa_gas(2)%conc = HNO3_init
+          salsa_gas(3)%conc = NH3_init
+          salsa_gas(4)%conc = OCNV_init
+          salsa_gas(5)%conc = OCSV_init 
+       ENDIF
+!
+!--    Set initial value for gas compound tracers and initial values
+       salsa_gas(1)%init = H2SO4_init
+       salsa_gas(2)%init = HNO3_init
+       salsa_gas(3)%init = NH3_init
+       salsa_gas(4)%init = OCNV_init
+       salsa_gas(5)%init = OCSV_init      
+    ENDIF
+!
+!-- Aerosol radius in each bin: dry and wet (m)
+    Ra_dry = 1.0E-10_wp
 !    
-!-- Initilisation actions that are NOT conducted for restart runs
-    IF ( .NOT. read_restart_data_salsa )  THEN    
-    
-       DO  b = 1, nbins
-          aerosol_number(b)%conc      = nclim
-          aerosol_number(b)%conc_p    = 0.0_wp
-          aerosol_number(b)%tconc_m   = 0.0_wp
-          aerosol_number(b)%flux_s    = 0.0_wp
-          aerosol_number(b)%diss_s    = 0.0_wp
-          aerosol_number(b)%flux_l    = 0.0_wp
-          aerosol_number(b)%diss_l    = 0.0_wp
-          aerosol_number(b)%init      = nclim
-          aerosol_number(b)%sums_ws_l = 0.0_wp
+!-- Initialise aerosol tracers    
+    aero(:)%vhilim   = 0.0_wp
+    aero(:)%vlolim   = 0.0_wp
+    aero(:)%vratiohi = 0.0_wp
+    aero(:)%vratiolo = 0.0_wp
+    aero(:)%dmid     = 0.0_wp
+!
+!-- Initialise the sectional particle size distribution
+    CALL set_sizebins()
+!
+!-- Initialise location-dependent aerosol size distributions and 
+!-- chemical compositions:
+    CALL aerosol_init 
+!
+!-- Initalisation run of SALSA
+    DO  i = nxl, nxr
+       DO  j = nys, nyn
+          CALL salsa_driver( i, j, 1 )
+          CALL salsa_diagnostics( i, j )
        ENDDO
-       DO  c = 1, ncc_tot*nbins
-          aerosol_mass(c)%conc      = mclim
-          aerosol_mass(c)%conc_p    = 0.0_wp
-          aerosol_mass(c)%tconc_m   = 0.0_wp
-          aerosol_mass(c)%flux_s    = 0.0_wp
-          aerosol_mass(c)%diss_s    = 0.0_wp
-          aerosol_mass(c)%flux_l    = 0.0_wp
-          aerosol_mass(c)%diss_l    = 0.0_wp
-          aerosol_mass(c)%init      = mclim
-          aerosol_mass(c)%sums_ws_l = 0.0_wp
-       ENDDO
-       
-       IF ( .NOT. salsa_gases_from_chem )  THEN
-          DO  g = 1, ngast
-             salsa_gas(g)%conc_p    = 0.0_wp
-             salsa_gas(g)%tconc_m   = 0.0_wp
-             salsa_gas(g)%flux_s    = 0.0_wp
-             salsa_gas(g)%diss_s    = 0.0_wp
-             salsa_gas(g)%flux_l    = 0.0_wp
-             salsa_gas(g)%diss_l    = 0.0_wp
-             salsa_gas(g)%sums_ws_l = 0.0_wp
-          ENDDO
-       
-!
-!--       Set initial value for gas compound tracers and initial values
-          salsa_gas(1)%conc = H2SO4_init
-          salsa_gas(1)%init = H2SO4_init
-          salsa_gas(2)%conc = HNO3_init
-          salsa_gas(2)%init = HNO3_init
-          salsa_gas(3)%conc = NH3_init
-          salsa_gas(3)%init = NH3_init
-          salsa_gas(4)%conc = OCNV_init
-          salsa_gas(4)%init = OCNV_init
-          salsa_gas(5)%conc = OCSV_init
-          salsa_gas(5)%init = OCSV_init      
-       ENDIF
-!
-!--    Aerosol radius in each bin: dry and wet (m)
-       Ra_dry = 1.0E-10_wp
-!    
-!--    Initialise aerosol tracers    
-       aero(:)%vhilim   = 0.0_wp
-       aero(:)%vlolim   = 0.0_wp
-       aero(:)%vratiohi = 0.0_wp
-       aero(:)%vratiolo = 0.0_wp
-       aero(:)%dmid     = 0.0_wp
-!
-!--    Initialise the sectional particle size distribution
-       CALL set_sizebins()
-!
-!--    Initialise location-dependent aerosol size distributions and 
-!--    chemical compositions:
-       CALL aerosol_init 
-!
-!--    Initalisation run of SALSA
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             CALL salsa_driver( i, j, 1 )
-             CALL salsa_diagnostics( i, j )
-          ENDDO
-       ENDDO 
-    ENDIF
+    ENDDO 
 !
 !-- Set the aerosol and gas sources
@@ -1419,6 +1419,6 @@
     
     USE netcdf_data_input_mod,                                                 &
-        ONLY:  get_attribute, netcdf_data_input_get_dimension_length,          &
-               get_variable, open_read_file
+        ONLY:  get_attribute, get_variable,                                    &
+               netcdf_data_input_get_dimension_length, open_read_file
     
     IMPLICIT NONE
@@ -1485,5 +1485,6 @@
 !
 !--       Input heights   
-          CALL netcdf_data_input_get_dimension_length( id_faero, nz_file, "profile_z" ) 
+          CALL netcdf_data_input_get_dimension_length( id_faero, nz_file,      &
+                                                       "profile_z" ) 
           
           ALLOCATE( pr_z(nz_file), pr_mass_fracs_a(maxspec,nz_file),           &
@@ -1628,5 +1629,6 @@
 !
 !--       Input heights   
-          CALL netcdf_data_input_get_dimension_length( id_fchem, nz_file, "profile_z" ) 
+          CALL netcdf_data_input_get_dimension_length( id_fchem, nz_file,      &
+                                                       "profile_z" ) 
           ALLOCATE( pr_z(nz_file), pr_gas(ngast,nz_file) ) 
           CALL get_variable( id_fchem, 'profile_z', pr_z ) 
@@ -2025,5 +2027,7 @@
 !> This routine reads the respective restart data.
 !------------------------------------------------------------------------------!
- SUBROUTINE salsa_rrd_local  
+ SUBROUTINE salsa_rrd_local( i, k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,        &
+                             nxr_on_file, nynf, nync, nyn_on_file, nysf,       &
+                             nysc, nys_on_file, tmp_3d, found )
 
     
@@ -2035,42 +2039,57 @@
     INTEGER(iwp) ::  g  !<
     INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<   
+    INTEGER(iwp) ::  k  !<
+    INTEGER(iwp) ::  nxlc            !<
+    INTEGER(iwp) ::  nxlf            !<
+    INTEGER(iwp) ::  nxl_on_file     !<
+    INTEGER(iwp) ::  nxrc            !<
+    INTEGER(iwp) ::  nxrf            !<
+    INTEGER(iwp) ::  nxr_on_file     !<
+    INTEGER(iwp) ::  nync            !<
+    INTEGER(iwp) ::  nynf            !<
+    INTEGER(iwp) ::  nyn_on_file     !<
+    INTEGER(iwp) ::  nysc            !<
+    INTEGER(iwp) ::  nysf            !<
+    INTEGER(iwp) ::  nys_on_file     !<
+
+    LOGICAL, INTENT(OUT)  ::  found
+
+    REAL(wp), &
+       DIMENSION(nzb:nzt+1,nys_on_file-nbgp:nyn_on_file+nbgp,nxl_on_file-nbgp:nxr_on_file+nbgp) :: tmp_3d   !<
+       
+    found = .FALSE.
     
     IF ( read_restart_data_salsa )  THEN
-       READ ( 13 )  field_char
-
-       DO  WHILE ( TRIM( field_char ) /= '*** end salsa ***' )
+    
+       SELECT CASE ( restart_string(1:length) )
        
-          DO b = 1, nbins
-             READ ( 13 )  aero(b)%vlolim
-             READ ( 13 )  aero(b)%vhilim
-             READ ( 13 )  aero(b)%dmid
-             READ ( 13 )  aero(b)%vratiohi
-             READ ( 13 )  aero(b)%vratiolo
-          ENDDO
-
-          DO  i = nxl, nxr
-             DO  j = nys, nyn
-                DO k = nzb+1, nzt
-                   DO  b = 1, nbins
-                      READ ( 13 )  aerosol_number(b)%conc(k,j,i)
-                      DO  c = 1, ncc_tot
-                         READ ( 13 )  aerosol_mass((c-1)*nbins+b)%conc(k,j,i)
-                      ENDDO
-                   ENDDO
-                   IF ( .NOT. salsa_gases_from_chem )  THEN
-                      DO  g = 1, ngast
-                         READ ( 13 )  salsa_gas(g)%conc(k,j,i)
-                      ENDDO 
-                   ENDIF
-                ENDDO
+          CASE ( 'aerosol_number' )
+             DO  b = 1, nbins
+                IF ( k == 1 )  READ ( 13 ) tmp_3d
+                aerosol_number(b)%conc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = & 
+                               tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                found = .TRUE.
              ENDDO
-          ENDDO
-
-          READ ( 13 )  field_char
-
-       ENDDO
        
+          CASE ( 'aerosol_mass' )
+             DO  c = 1, ncc_tot * nbins
+                IF ( k == 1 )  READ ( 13 ) tmp_3d
+                aerosol_mass(c)%conc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) = & 
+                               tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                found = .TRUE.
+             ENDDO
+          
+          CASE ( 'salsa_gas' )
+             DO  g = 1, ngast
+                IF ( k == 1 )  READ ( 13 ) tmp_3d
+                salsa_gas(g)%conc(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =  & 
+                               tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
+                found = .TRUE.
+             ENDDO
+             
+          CASE DEFAULT
+             found = .FALSE.
+             
+       END SELECT
     ENDIF
 
@@ -2093,37 +2112,21 @@
     INTEGER(iwp) ::  c  !<
     INTEGER(iwp) ::  g  !<
-    INTEGER(iwp) ::  i  !<
-    INTEGER(iwp) ::  j  !<
-    INTEGER(iwp) ::  k  !<
     
     IF ( write_binary  .AND.  write_binary_salsa )  THEN
-       
-       DO b = 1, nbins
-          WRITE ( 14 )  aero(b)%vlolim
-          WRITE ( 14 )  aero(b)%vhilim
-          WRITE ( 14 )  aero(b)%dmid
-          WRITE ( 14 )  aero(b)%vratiohi
-          WRITE ( 14 )  aero(b)%vratiolo
+    
+       CALL wrd_write_string( 'aerosol_number' )
+       DO  b = 1, nbins
+          WRITE ( 14 )  aerosol_number(b)%conc
        ENDDO
        
-       DO  i = nxl, nxr
-          DO  j = nys, nyn
-             DO  k = nzb+1, nzt
-                DO  b = 1, nbins
-                   WRITE ( 14 )  aerosol_number(b)%conc(k,j,i)
-                   DO  c = 1, ncc_tot
-                      WRITE ( 14 )  aerosol_mass((c-1)*nbins+b)%conc(k,j,i)
-                   ENDDO
-                ENDDO
-                IF ( .NOT. salsa_gases_from_chem )  THEN
-                   DO  g = 1, ngast
-                      WRITE ( 14 )  salsa_gas(g)%conc(k,j,i)
-                   ENDDO 
-                ENDIF
-             ENDDO
-          ENDDO
+       CALL wrd_write_string( 'aerosol_mass' )
+       DO  c = 1, nbins*ncc_tot
+          WRITE ( 14 )  aerosol_mass(c)%conc
        ENDDO
        
-       WRITE ( 14 )  '*** end salsa ***   '
+       CALL wrd_write_string( 'salsa_gas' )
+       DO  g = 1, ngast
+          WRITE ( 14 )  salsa_gas(g)%conc
+       ENDDO
           
     ENDIF
@@ -2765,33 +2768,33 @@
     USE arrays_3d,                                                             &
         ONLY: p, pt, q, zu
-        
+       
     USE basic_constants_and_equations_mod,                                     &
-        ONLY:  barometric_formula, exner_function, ideal_gas_law_rho, magnus 
-        
+        ONLY:  barometric_formula, exner_function, ideal_gas_law_rho, magnus
+       
     USE control_parameters,                                                    &
         ONLY: pt_surface, surface_pressure
-        
+       
     IMPLICIT NONE
    
     INTEGER(iwp), INTENT(in) ::  i
-    INTEGER(iwp), INTENT(in) ::  j 
+    INTEGER(iwp), INTENT(in) ::  j
     REAL(wp), DIMENSION(:), INTENT(inout) ::  adn_ij
-    REAL(wp), DIMENSION(:), INTENT(inout) ::  p_ij        
+    REAL(wp), DIMENSION(:), INTENT(inout) ::  p_ij       
     REAL(wp), DIMENSION(:), INTENT(inout) ::  temp_ij
     REAL(wp), DIMENSION(:), INTENT(inout), OPTIONAL ::  cw_ij
-    REAL(wp), DIMENSION(:), INTENT(inout), OPTIONAL ::  cs_ij 
-    REAL(wp), DIMENSION(nzb:nzt+1) ::  e_s !< saturation vapour pressure 
+    REAL(wp), DIMENSION(:), INTENT(inout), OPTIONAL ::  cs_ij
+    REAL(wp), DIMENSION(nzb:nzt+1) ::  e_s !< saturation vapour pressure
                                            !< over water (Pa)
     REAL(wp) ::  t_surface !< absolute surface temperature (K)
 !
 !-- Pressure p_ijk (Pa) = hydrostatic pressure + perturbation pressure (p)
-    t_surface = pt_surface * exner_function( surface_pressure )
-    p_ij(:) = 100.0_wp * barometric_formula( zu, t_surface, surface_pressure ) &
+    t_surface = pt_surface * exner_function( surface_pressure * 100.0_wp )
+    p_ij(:) = barometric_formula( zu, t_surface, surface_pressure * 100.0_wp ) &
               + p(:,j,i)
 !             
 !-- Absolute ambient temperature (K)
-    temp_ij(:) = pt(:,j,i) * exner_function( p_ij(:) )        
-!
-!-- Air density 
+    temp_ij(:) = pt(:,j,i) * exner_function( p_ij(:) )       
+!
+!-- Air density
     adn_ij(:) = ideal_gas_law_rho( p_ij(:), temp_ij(:) )
 !
@@ -2803,8 +2806,9 @@
 !-- Saturation mixing ratio r_s (kg/kg) from vapour pressure at temp (Pa)
     IF ( PRESENT( cs_ij ) )  THEN
-       e_s(:) = magnus( temp_ij(:) ) 
-       cs_ij(:) = ( 0.622_wp * e_s / ( p_ij(:) - e_s(:) ) ) * adn_ij(:)  
+       e_s(:) = 611.0_wp * EXP( alv_d_rv * ( 3.6609E-3_wp - 1.0_wp /           &
+                temp_ij(:) ) )! magnus( temp_ij(:) )
+       cs_ij(:) = ( 0.622_wp * e_s / ( p_ij(:) - e_s(:) ) ) * adn_ij(:) 
     ENDIF
-    
+
  END SUBROUTINE salsa_thrm_ij 
 
@@ -7877,6 +7881,6 @@
     
     USE netcdf_data_input_mod,                                                 &
-        ONLY:  get_attribute, netcdf_data_input_get_dimension_length,          &
-               get_variable, open_read_file
+        ONLY:  get_attribute, get_variable,                                    &
+               netcdf_data_input_get_dimension_length, open_read_file
     
     USE surface_mod,                                                           &
@@ -7985,5 +7989,6 @@
 !                              
 !--       Index of gaseous compounds
-          CALL netcdf_data_input_get_dimension_length( id_fchem, ng_file, "nspecies" )  
+          CALL netcdf_data_input_get_dimension_length( id_fchem, ng_file,      &
+                                                       "nspecies" )  
           IF ( ng_file < 5 )  THEN
              message_string = 'Some gaseous emissions missing.'
@@ -8200,5 +8205,6 @@
 !
 !--    Emission time step
-       CALL netcdf_data_input_get_dimension_length( id_faero, n_dt, 'dt_emission' ) 
+       CALL netcdf_data_input_get_dimension_length( id_faero, n_dt,            &
+                                                    'dt_emission' ) 
        IF ( n_dt > 1 )  THEN
           CALL location_message( '    salsa_set_source: hourly emission data'//&
@@ -8410,5 +8416,5 @@
        DO  n = 1, ncat_emission
           DO  g = 1, ngast
-             IF ( .NOT. salsa_gas(g)%source(n,j,i) > 0.0_wp )  THEN
+             IF ( salsa_gas(g)%source(n,j,i) < 0.0_wp )  THEN
                 salsa_gas(g)%source(n,j,i) = 0.0_wp
                 CYCLE
@@ -9138,6 +9144,6 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      PM25_av(k,j,i) = PM25_av(k,j,i)                          &
-                                        / REAL( average_count_3d, KIND=wp )
+                      PM25_av(k,j,i) = PM25_av(k,j,i) /                        &
+                                       REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -9148,6 +9154,6 @@
                 DO  j = nysg, nyng
                    DO  k = nzb, nzt+1
-                      PM10_av(k,j,i) = PM10_av(k,j,i)                          &
-                                        / REAL( average_count_3d, KIND=wp )
+                      PM10_av(k,j,i) = PM10_av(k,j,i) /                        &
+                                       REAL( average_count_3d, KIND=wp )
                    ENDDO
                 ENDDO
@@ -9168,6 +9174,6 @@
                    DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
-                         to_be_resorted(k,j,i) = to_be_resorted(k,j,i)         &
-                                             / REAL( average_count_3d, KIND=wp )
+                         to_be_resorted(k,j,i) = to_be_resorted(k,j,i) /       &
+                                                 REAL( average_count_3d, KIND=wp )
                       ENDDO
                    ENDDO
@@ -9188,10 +9194,11 @@
 !> Subroutine defining 2D output variables
 !------------------------------------------------------------------------------!
- SUBROUTINE salsa_data_output_2d( av, variable, found, grid, mode,             &
-                                      local_pf, two_d )
+ SUBROUTINE salsa_data_output_2d( av, variable, found, grid, mode, local_pf,   &
+                                  two_d, nzb_do, nzt_do )
  
     USE indices
 
     USE kinds
+
 
     IMPLICIT NONE
@@ -9202,26 +9209,30 @@
     CHARACTER (LEN=5) ::  vari       !<  trimmed format of variable
 
-    INTEGER(iwp) ::  av   !< 
-    INTEGER(iwp) ::  b    !<
-    INTEGER(iwp) ::  c    !< 
-    INTEGER(iwp) ::  i    !<
-    INTEGER(iwp) ::  icc  !< index of a chemical compound
-    INTEGER(iwp) ::  j    !< 
-    INTEGER(iwp) ::  k    !< 
-
-    LOGICAL ::  found   !< 
-    LOGICAL ::  two_d   !< flag parameter that indicates 2D variables 
-                        !< (horizontal cross sections)
-    
-    REAL(wp) ::  df       !< For calculating LDSA: fraction of particles 
-                          !< depositing in the alveolar (or tracheobronchial)
-                          !< region of the lung. Depends on the particle size 
-    REAL(wp) ::  mean_d   !< Particle diameter in micrometres
-    REAL(wp) ::  nc       !< Particle number concentration in units 1/cm**3
-    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb:nzt+1) ::  local_pf !< local
-       !< array to which output data is resorted to
-    REAL(wp) ::  temp_bin !< 
-    REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted  !< points to 
-                                                     !< selected output variable
+    INTEGER(iwp) ::  av      !< 
+    INTEGER(iwp) ::  b       !< running index: size bins
+    INTEGER(iwp) ::  c       !< running index: mass bins
+    INTEGER(iwp) ::  i       !<
+    INTEGER(iwp) ::  icc     !< index of a chemical compound
+    INTEGER(iwp) ::  j       !< 
+    INTEGER(iwp) ::  k       !< 
+    INTEGER(iwp) ::  nzb_do  !< 
+    INTEGER(iwp) ::  nzt_do  !< 
+
+    LOGICAL ::  found        !< 
+    LOGICAL ::  two_d        !< flag parameter that indicates 2D variables 
+                             !< (horizontal cross sections)
+    
+    REAL(wp) ::  df          !< For calculating LDSA: fraction of particles 
+                             !< depositing in the alveolar (or tracheobronchial)
+                             !< region of the lung. Depends on the particle size 
+    REAL(wp) ::  fill_value = -9999.0_wp  !< value for the _FillValue attribute                          
+    REAL(wp) ::  mean_d      !< Particle diameter in micrometres
+    REAL(wp) ::  nc          !< Particle number concentration in units 1/cm**3
+    REAL(wp) ::  temp_bin    !< temporary array for calculating output variables
+    
+    REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !< output
+    
+    REAL(wp), DIMENSION(:,:,:), POINTER ::  to_be_resorted           !< pointer
+    
     
     found = .TRUE.
@@ -9238,7 +9249,7 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1
+                DO  k = nzb_do, nzt_do
                    local_pf(i,j,k) = MERGE( salsa_gas(icc)%conc(k,j,i),        &
-                                            REAL( -999.0_wp, KIND = wp ),      &
+                                            REAL( fill_value, KIND = wp ),     &
                                             BTEST( wall_flags_0(k,j,i), 0 ) ) 
                 ENDDO
@@ -9253,7 +9264,7 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1
+                DO  k = nzb_do, nzt_do
                    local_pf(i,j,k) = MERGE( to_be_resorted(k,j,i),             &
-                                            REAL( -999.0_wp, KIND = wp ),      &
+                                            REAL( fill_value, KIND = wp ),     &
                                             BTEST( wall_flags_0(k,j,i), 0 ) ) 
                 ENDDO
@@ -9268,5 +9279,5 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1
+                DO  k = nzb_do, nzt_do
                    temp_bin = 0.0_wp
                    DO  b = 1, nbins
@@ -9286,6 +9297,6 @@
                       temp_bin = temp_bin + pi * mean_d**2.0_wp * df * nc 
                    ENDDO
-                   local_pf(i,j,k) = MERGE( temp_bin,  REAL( -999.0_wp,        &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                   local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = & 
+                                            wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
                 ENDDO
              ENDDO
@@ -9294,7 +9305,8 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1
-                   local_pf(i,j,k) = MERGE( LDSA_av(k,j,i), REAL( -999.0_wp,   &
-                                  KIND = wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                DO  k = nzb_do, nzt_do
+                   local_pf(i,j,k) = MERGE( LDSA_av(k,j,i), REAL( fill_value,  &
+                                            KIND = wp ), BTEST(                &
+                                            wall_flags_0(k,j,i), 0 ) ) 
                 ENDDO
              ENDDO
@@ -9303,12 +9315,28 @@
 
        IF ( mode == 'xy' )  grid = 'zu'
-    
-    ELSEIF ( TRIM( variable(1:6) ) == 'N_bin1' )  THEN
+       
+    ELSEIF ( TRIM( variable(1:5) ) == 'N_bin' )  THEN
+       
+       vari = TRIM( variable( 6:LEN( TRIM( variable ) ) - 3 ) )
+    
+       IF ( TRIM( vari ) == '1' ) b = 1
+       IF ( TRIM( vari ) == '2' ) b = 2
+       IF ( TRIM( vari ) == '3' ) b = 3
+       IF ( TRIM( vari ) == '4' ) b = 4
+       IF ( TRIM( vari ) == '5' ) b = 5
+       IF ( TRIM( vari ) == '6' ) b = 6
+       IF ( TRIM( vari ) == '7' ) b = 7
+       IF ( TRIM( vari ) == '8' ) b = 8
+       IF ( TRIM( vari ) == '9' ) b = 9
+       IF ( TRIM( vari ) == '10' ) b = 10
+       IF ( TRIM( vari ) == '11' ) b = 11
+       IF ( TRIM( vari ) == '12' ) b = 12
+       
        IF ( av == 0 )  THEN
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( aerosol_number(1)%conc(k,j,i),     &
-                                            REAL( -999.0_wp, KIND = wp ),      &
+                DO  k = nzb_do, nzt_do                      
+                   local_pf(i,j,k) = MERGE( aerosol_number(b)%conc(k,j,i),     &
+                                            REAL( fill_value, KIND = wp ),     &
                                             BTEST( wall_flags_0(k,j,i), 0 ) ) 
                 ENDDO
@@ -9318,7 +9346,7 @@
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,1),                 &
-                                            REAL( -999.0_wp, KIND = wp ),      &
+                DO  k = nzb_do, nzt_do                      
+                   local_pf(i,j,k) = MERGE( Nbins_av(k,j,i,b),                 &
+                                            REAL( fill_value, KIND = wp ),     &
                                             BTEST( wall_flags_0(k,j,i), 0 ) ) 
                 ENDDO
@@ -9326,13 +9354,18 @@
           ENDDO
        ENDIF
-    
-    ELSEIF ( TRIM( variable(1:6) ) == 'N_bin2' )  THEN
+       
+       IF ( mode == 'xy' )  grid = 'zu'
+    
+    ELSEIF ( TRIM( variable(1:4) ) == 'Ntot' )  THEN
        IF ( av == 0 )  THEN
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                DO  k = nzb, nzt+1                      
-                   local_pf(i,j,k) = MERGE( aerosol_number(2)%conc(k,j,i),     &
-                                            REAL( -999.0_wp, KIND = wp ),      &
-                                            BTEST( wall_flags_0(k,j,i), 0 ) ) 
+                DO  k = nzb_do, nzt_do
+                   temp_bin = 0.0_wp
+                   DO  b = 1, nbins
+                      temp_bin = temp_bin + aerosol_number(b)%conc(k,j,i)
+                   ENDDO
+                   local_pf(i,j,k) = MERGE( temp_bin, REAL( fill_value, KIND = &
+                                            wp ), BTEST( wall_flags_0(k,j,i), 0 ) ) 
                 ENDDO
              ENDDO
